/* cdfcomment -- Add a comment to a Candis file */
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "cdfhdr.h"

/* Candis stuff */
static char hbuff[HBMAX][LINE];
static long nsbuff,nvbuff;
static float *sbuff,*vbuff;

main(argc,argv)
int argc;
char *argv[];
{
  char cline[LINE];

/* check args */
  if (argc != 2) {
    fprintf(stderr,"Usage: cdfcomment comment (quote multi-word comments)\n");
    exit(1);
  }

/* get a header */
  gethdr(stdin,hbuff,HBMAX);
  if (getfmt(hbuff,HBMAX) != 'f') {
    fprintf(stderr,"cdfcomment: float format expected\n");
    exit(1);
  }

/* add the comment */
  if (strlen(argv[1]) > LINE - 2) {
    fprintf(stderr,"Cdfcomment: comment string too long\n");
    exit(1);
  }
  sprintf(cline,"%s\n",argv[1]);
  addcline(hbuff,HBMAX,cline);

/* write the header */
  puthdr(stdout,hbuff,HBMAX);

/* get sizes of buffers and make space */
  nsbuff = elemcnt(hbuff,HBMAX,'s');
  sbuff = getbuff(nsbuff);
  nvbuff = elemcnt(hbuff,HBMAX,'v');
  vbuff = getbuff(nvbuff);

/* transfer static slice */
  if (getslice(stdin,nsbuff,sbuff) == EOF) {
    fprintf(stderr,"cdfcomment: unexpected eof while reading static slice\n");
    exit(1);
  }
  putslice(stdout,nsbuff,sbuff);

/* transfer variable slices */
  while (getslice(stdin,nvbuff,vbuff) != EOF) {
    putslice(stdout,nvbuff,vbuff);
  }

/* exit like they say you have to */
  exit(0);
}
