/* cdfnull -- create a null candis file with specified dimensions */
#include <stdio.h>
#include <math.h>
#include "cdfhdr.h"

static int ndims;
static char cline[81];
static char *dname1,*dname2,*dname3,*dname4;
static int dsize1,dsize2,dsize3,dsize4;
static float start1,start2,start3,start4;
static float incr1,incr2,incr3,incr4;
static int handle,dh1,dh2,dh3,dh4;
static float dummy;

main(argc,argv)
int argc;
char *argv[];
{

/* check command line */
  if (argc == 5) {
    ndims = 1;
  }
  else if (argc == 9) {
    ndims = 2;
  }
  else if (argc == 13) {
    ndims = 3;
  }
  else if (argc == 17) {
    ndims = 4;
  }
  else {
    fprintf(stderr,"Usage: cdfnull dname1 dsize1 start1 incr1 ...\n");
    exit(1);
  }

/* extract information */
  if (argc >= 5) {
    dname1 = argv[1];
    dsize1 = atoi(argv[2]);
    start1 = atof(argv[3]);
    incr1 = atof(argv[4]);
  }
  if (argc >= 9) {
    dname2 = argv[5];
    dsize2 = atoi(argv[6]);
    start2 = atof(argv[7]);
    incr2 = atof(argv[8]);
  }
  if (argc >= 13) {
    dname3 = argv[9];
    dsize3 = atoi(argv[10]);
    start3 = atof(argv[11]);
    incr3 = atof(argv[12]);
  }
  if (argc >= 17) {
    dname4 = argv[13];
    dsize4 = atoi(argv[14]);
    start4 = atof(argv[15]);
    incr4 = atof(argv[16]);
  }

/* make the file */
  handle = candiscreate("-",0);

/* add comment */
  candiscomment(handle,"cdfnull:");
  if (ndims > 0) {
    sprintf(cline,"  %s %s %s %s",argv[1],argv[2],argv[3],argv[4]);
    candiscomment(handle,cline);
  }
  if (ndims > 1) {
    sprintf(cline,"  %s %s %s %s",argv[5],argv[6],argv[7],argv[8]);
    candiscomment(handle,cline);
  }
  if (ndims > 2) {
    sprintf(cline,"  %s %s %s %s",argv[9],argv[10],argv[11],argv[12]);
    candiscomment(handle,cline);
  }
  if (ndims > 3) {
    sprintf(cline,"  %s %s %s %s",argv[13],argv[14],argv[15],argv[16]);
    candiscomment(handle,cline);
  }

/* make the dimensions */
  if (argc >= 5) {
    dh1 = candisdim(handle,dname1,dsize1,start1,incr1);
  }
  if (argc >= 9) {
    dh2 = candisdim(handle,dname2,dsize2,start2,incr2);
  }
  if (argc >= 13) {
    dh3 = candisdim(handle,dname3,dsize3,start3,incr3);
  }
  if (argc >= 17) {
    dh4 = candisdim(handle,dname4,dsize4,start4,incr4);
  }

/* add one dummy field */
  dummy = 0.;
  candisfld(handle,"dummy",0,dh1,dh2,dh3,dh4,&dummy);

/* write the file and exit */
  candiswrite(handle);
}
