/* cdfparams -- Add an arbitrary number of parameters to a Candis file */
#include <stdio.h>
#include <math.h>
#include "cdfhdr.h"

/* Candis stuff */
static char hbuff[HBMAX][LINE];
static long nsbuff,nvbuff;
static float *sbuff,*vbuff;

main(argc,argv)
int argc;
char *argv[];
{
  int i;

/* check args */
  if (argc % 2 != 1 || argc < 3) {
    fprintf(stderr,"Usage: cdfparams param value ...\n");
    exit(1);
  }

/* get a header */
  gethdr(stdin,hbuff,HBMAX);
  if (getfmt(hbuff,HBMAX) != 'f') {
    fprintf(stderr,"cdfparams: float format expected\n");
    exit(1);
  }

/* add the parameters */
  i = 1;
  while (i < argc) {
    addpar(hbuff,HBMAX,argv[i],argv[i + 1]);
    i += 2;
  }

/* write the header */
  puthdr(stdout,hbuff,HBMAX);

/* get sizes of buffers and make space */
  nsbuff = elemcnt(hbuff,HBMAX,'s');
  sbuff = getbuff(nsbuff);
  nvbuff = elemcnt(hbuff,HBMAX,'v');
  vbuff = getbuff(nvbuff);

/* transfer static slice */
  if (getslice(stdin,nsbuff,sbuff) == EOF) {
    fprintf(stderr,"cdfparams: unexpected eof while reading static slice\n");
    exit(1);
  }
  putslice(stdout,nsbuff,sbuff);

/* transfer variable slices */
  while (getslice(stdin,nvbuff,vbuff) != EOF) {
    putslice(stdout,nvbuff,vbuff);
  }

/* exit like they say you have to */
  exit(0);
}
