/* cdfsplit -- This program writes the header and slices to separate
 * files so that the header may be edited directly.
 */
#include <stdio.h>
#include "cdfhdr.h"

static char hbuff[HBMAX][LINE];
static float *sbuff,*vbuff;
static long nsbuff,nvbuff;
static FILE *ofile;

main(argc,argv)
int argc;
char *argv[];
{
/* check args */
  if (argc != 2) {
    fprintf(stderr,"Usage: cdfsplit header_file\n");
    exit(1);
  }
/* get header */
  gethdr(stdin,hbuff,HBMAX);
/* check format */
  if (getfmt(hbuff,HBMAX) != 'f') {
    fprintf(stderr,"cdfsplit: float format expected\n");
    exit(1);
  }
/* write header to file specified on command line */
  if ((ofile = fopen(argv[1],"w")) == NULL) {
    fprintf(stderr,"cdfsplit: can't open file %s\n",argv[1]);
    exit(1);
  }
  puthdr(ofile,hbuff,HBMAX);
  close(ofile);
/* transfer static slice */
  nsbuff = elemcnt(hbuff,HBMAX,'s');
  sbuff = getbuff(nsbuff);
  getslice(stdin,nsbuff,sbuff);
  putslice(stdout,nsbuff,sbuff);
/* transfer variable slices */
  nvbuff = elemcnt(hbuff,HBMAX,'v');
  vbuff = getbuff(nvbuff);
  while (getslice(stdin,nvbuff,vbuff) != EOF) {
    putslice(stdout,nvbuff,vbuff);
  }
  exit(0);
}
