/* cdfthresh                                                             */
/* cdfthresh 'var_field <_or_> value' ....                               */
/* cdfthresh goes thru the slice and for similar fields (fields with the */
/* same number of elements) and checks the condition in the command line */
/* if met the data is sent; otherwise bad data is sent.                  */
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "cdfhdr.h"

#define NOCHAR -1

static int *numel,*flag,*place;    /* contains info from the command line */
static float *value;               /* contains more command line info */
static char hbuffer[HBMAX][LINE];  /* buffer for header info */
static float *sbuff;               /* buffer for slice data */
static int pos();

main(argc, argv)
int argc;
char *argv[];
{
  int loop,loop1,loop2;     /* index used in loops */
  int vpos,stat;            /* position of current field being accesed */
  int numcom,numvar;        /* # of command line arguments */
  int where,n;              /* used in decoding command line arguments */
  int varelm[HBMAX];        /* table that hold number of elements for vars */
  int pt[HBMAX];            /* table that holds pointer to start within buff */
  long nel;                 /* # elements to read or write */
  char cl[LINE];            /* new comment line data and temp storage */
  float bad,badlim;         /* contains values of bad and badlim */
  float val;                /* used in comparision of data with argument */
  struct field *fp;         /* pointer to the field structure of data */

/* check argument list */
  if (argc == 1) {
    fprintf(stderr,"Usage: cdfthresh 'var_field <_or_> value' ...\n");
    fprintf(stderr,"  or : cdfthresh 'var_field <_or_> badlim' ..\n");
    exit(1);
  }
/* get header buffer from standard input */
  gethdr(stdin,hbuffer,HBMAX);
/* if format is not float, die */
  if (getfmt(hbuffer,HBMAX) != 'f') {
    fprintf(stderr,"cdfrdim: format must be float!\n");
    exit(1);
  }
/* find values of bad and badlim */
  if (seekpar(hbuffer,HBMAX,"bad",cl)==FAIL)
    bad=BAD;
  else
    bad=atof(cl);
  if (seekpar(hbuffer,HBMAX,"badlim",cl)==FAIL)
    badlim=BADLIM;
  else
    badlim=atof(cl);
/* determine the number of command set on the argument line */
  numcom=argc-1;
  numel=(int*)malloc(sizeof(int)*numcom);
  flag=(int*)malloc(sizeof(int)*numcom);
  place=(int*)malloc(sizeof(int)*numcom);
  if (numel == (int*)NULL || flag == (int*)NULL || place == (int*)NULL) {
    fprintf(stderr,"cdfthresh: can't allocate enough memory\n");
    exit(1);
  }
  value=getbuff(numcom);
  for (loop=0;loop<numcom;loop++) {
    numel[loop]=flag[loop]=0;
/* determine if greater or less than */
/* if > then flag = 1 if < then flag = -1 */
    if((where=pos(argv[loop+1],'<')) != NOCHAR)
      flag[loop]--;
    if ((n=pos(argv[loop+1],'>')) != NOCHAR) {
      flag[loop]++;
      where=n;
    }
/* if neither then die */
    if (flag[loop]==0) {
      fprintf(stderr,"cdfthresh: %s doesn't follow format\n",argv[loop+1]);
      exit(1);
    }
/* extract name of the variable */
    n=where;
    if (argv[loop+1][where-1] == ' ')
      --n;
    strncpy(cl,argv[loop+1],n);
    cl[n]='\0';
    if ((fp=seekfld(hbuffer,HBMAX,'v',cl)) == NULL) {
      fprintf(stderr,"cdfthresh: %s field not found\n",cl);
      exit(1);
    }
    place[loop]=fp->ptr;
/* find the value to be used */
    where++;
    for (loop1=where;loop1<strlen(argv[loop+1]);loop1++)
      cl[loop1-where]=argv[loop+1][loop1];
    cl[loop1-where]='\0';
    if ((strcmp(cl,"badlim")==0)||(strcmp(cl,"BADLIM")==0)||
        (strcmp(cl," badlim")==0)||(strcmp(cl," BADLIM")==0))
      sprintf(cl,"%f\0",bad);
/* store results within an array */
    value[loop]=atof(cl);
    numel[loop]=fp->tsize;
  }
/* add comment to buffer then output it */
  addcline(hbuffer,HBMAX,"cdfthresh:\n");
  strcpy(cl," ");
  for (loop=1;loop < argc;loop ++) {
    strcat(cl," ");
    strcat(cl,argv[loop]);
  }
  strcat(cl,"\n");
  addcline(hbuffer,HBMAX,cl);
  puthdr(stdout,hbuffer,HBMAX);
/* transfer static slice data */
  nel=elemcnt(hbuffer,HBMAX,'s');
  sbuff=getbuff(nel);
  getslice(stdin,nel,sbuff);
  putslice(stdout,nel,sbuff);
  free(sbuff);
/* set up table that holds info about the variable fields */
  vpos = 0;
  while((fp=getfld(hbuffer,HBMAX,'v',vpos)) != NULL) {
    varelm[vpos]=fp->tsize;
    pt[vpos++]=fp->ptr;
  }
  numvar=vpos;
/* set up buffers for variable slices */
  nel=elemcnt(hbuffer,HBMAX,'v');
  sbuff=getbuff(nel);
/* cycle through variable slices */
  while(getslice(stdin,nel,sbuff)!=EOF) {
/* cycle through the fields mentioned in the command line */
    for (loop=0;loop<numcom;loop++) {
    val=value[loop];
/* loop thru all the elements in the field mention on command line */
      for (loop1=0;loop1<numel[loop];loop1++) {
        stat=0;
/* test the condition given, if the data doesn't pass then data goes bad */
/* if the test is for less than val */
        where = loop1+place[loop];
        if ((flag[loop] == -1)&&(fabs(val) < badlim)) {
          if ((sbuff[where] > val)&&(fabs(sbuff[where]) < badlim)) {
            sbuff[where]=bad;
            stat = -1;
          }
        }
/* if the test is for greater than val */
        else if ((flag[loop] == 1)&&(fabs(val) < badlim)) {
          if ((sbuff[where] < val)&&(fabs(sbuff[where]) < badlim)) {
            sbuff[where]=bad;
            stat = -1;
          }
        }
/* if the test is for greater than badlim */
        else if (flag[loop] == 1) {
          if (fabs(sbuff[where]) < badlim)
            stat = -1;
        }
/* if the test is for less than badlim */
        else if (flag[loop] == -1) {
          if (fabs(sbuff[where]) > badlim)
            stat = -1;
        }
/* if the data didn't pass the condition then */
        if (stat == -1) {
/* cycle through other fields that are similar and turn them bad also */
          for (loop2=0;loop2<numvar;loop2++) {
            if (varelm[loop2]==numel[loop])
              sbuff[pt[loop2]+loop1]=bad;
          }
        }
      }
    }
/* output slice and get the next one */
    putslice(stdout,nel,sbuff);
  }
  exit(0);
}

/* this routine determines the position of a character t within the string */
/* s and returns the place where it lies within the string or it returns   */
/* a NOCHAR if the character t is not found.                                 */
static int pos(s,t)
char s[],t;
{
  int i;

  for (i=0;s[i] != '\0';i++) {
    if (s[i] == t)
      return(i);
  }
  return(NOCHAR);
}
