/* ngradcart.h -- Contains common definitions */
/* $Id: ngradcart.h,v 1.4 2009/06/28 16:57:32 raymond Exp $ */

/* parameter list */
struct param_list {
  int aux;                           /* auxiliary wind file flag */
  char auxfilename[120];             /* name of auxiliary file */
  int clutterthresh;                 /* ground clutter elimination flag */
  float zmin0;                       /* min altitude under radar */
  float zmincoef;                    /* min altitude range coefficient */
  int propagation;                   /* propagation flag */
  float svx, svy;                    /* propagation components km/ks */
  float reftime;                     /* propagation reference time ks */
  int rangethresh;                   /* range thresholding flag */
  float minrange;                    /* minimum range accepted */
  int oldgeneration;                 /* if set use old gen doppler calc */
  int sphere;                        /* if set grid is in degrees, not km */
  int wzero;                         /* if set a2 has value where no data */
  int radar;                         /* use radar data */
  float a2val;                       /* value of a2 where no data if -z set */
  float lon0, lat0, alt0;            /* bottom, SW corner of box */
  float dx, dy, dz;                  /* cell dimensions */
  int nx, ny, nz;                    /* domain dimensions */
};

/* gridded input field list */
struct field_list {
  double *axx, *axy, *ayy, *axz, *ayz, *azz;
  double *bx, *by, *bz;
  double *time, *timesq;
  double *chisqbase;
  double *pcount;
  double *dbz;
  double *weightsum;
};

/* index macro */
#define I(ix,iy,iz) ((iz) + nz*((iy) + ny*(ix)))
