#ifndef CG_CONMINC_H_INCLUDED
#define CG_CONMINC_H_INCLUDED

typedef struct cgInfo
{
	double eps; /* eps and acc Set the global accuracy parameters for conmin */
	double acc; /*  -- Nash & Soffer pg.375 */
	int MXFUN;  /* MaxNumOfFunctionsEvaluations for CONMIN */
} cgInfo;

typedef struct ConCri /* ConvergenceCriteria */
{
	double g; /* value of convergence criteria base on gradient. */
	double x; /* value of convergence criteria base on solution. */
	double f; /* value of convergence criteria base on targetfunction@sol. */
	double c; /* 1 if convergence is satisfied zero otherwise. */
} ConCri;

typedef struct funInfo
{
	struct cgInfo cgi; /* CongugateGradientInfo */
	struct ConCri CC;
	void *userData;
} funInfo;

void cg_CONMINc(int N, double *X, double *F, double *G,
               struct funInfo *finfo,
               int (*CALCFG)(struct funInfo *,int,double *,double *,double *));
#endif
