/* smootht -- smoothingTerm */

//TODO remove lap c argument

#include "nggfit.h"
#include "ng3dvar_tf_smootht.h"
#include "ngutil.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>

//
// External functions
//
//double sqrt(double x);
//int GetGL(struct funInfo *finfo, int N);
//int gpe(int Nx, int Ny, int Nz, int c, int i, int j, int k);
//void stop();

//
// Local functions
//
static void lap(int HCB, int Nxg,int Nyg,int Nzg,int c,int l,int m,int n, 
				double A[][5], double *d2x, double *d2y, double *d2z, double *f);

// 
//-------------------------------------------------------------------
static void lap(int HCB, int Nxg,int Nyg,int Nzg,int c,int l,int m,int n, 
				double A[][5], double *d2x, double *d2y, double *d2z, double *f) {

	double del2x,del2y,del2z; //Second Partial Derivatives
//double dx2 = 1.0; //Dxg*Dxg;
//double dy2 = 1.0; //Dyg*Dyg;
//double dz2 = 1.0; //Dzg*Dzg;
	int pp;

//
// PxVc = A[x][0]Vc(i+2,j,k)+A[x][1]Vc(i+1,j,k)+A[x][2]Vc(i,j,k)+
//        A[x][3]Vc(i-1,j,k)+A[x][4]Vc(i-2,j,k)
//
// PyVc = A[y][0]Vc(i,j+2,k)+A[y][1]Vc(i,j+1,k)+A[y][2]Vc(i,j,k)+
//        A[y][3]Vc(i,j-1,k)+A[y][4]Vc(i,j-2,k)
//
// PzVc = A[z][0]Vc(i,j,k+2)+A[z][1]Vc(i,j,k+1)+A[z][2]Vc(i,j,k)+
//        A[z][3]Vc(i,j,k-1)+A[z][4]Vc(i,j,k-2)
//
// HLapVc = PxVc + PyVc 
// VLapVc = PzVc

	//Sanity Check -- we are still in the grid.
	if (l < 0 || l > (Nxg-1)) {fprintf(stderr,"lapc i OutOfBounds");exit(1);}
	if (m < 0 || m > (Nyg-1)) {fprintf(stderr,"lapc j OutOfBounds");exit(1);}
	if (n < 0 || n > (Nzg-1)) {fprintf(stderr,"lapc k OutOfBounds");exit(1);}

	//
	// Set coeficients according to location of the point
	// --default values are for an inner point.
	//
	A[0][0]=0.0; A[0][1]= 1.0; A[0][2]=-2.0; A[0][3]= 1.0; A[0][4]=0.0; 
	A[1][0]=0.0; A[1][1]= 1.0; A[1][2]=-2.0; A[1][3]= 1.0; A[1][4]=0.0; 
	A[2][0]=0.0; A[2][1]= 1.0; A[2][2]=-2.0; A[2][3]= 1.0; A[2][4]=0.0; 

	//Handel Boundaries assumming no hard assumptions on veritical
	//velocities at the top and bottom boundaries.
	if (l == 0)  
    {A[0][0]=1.0; A[0][1]=-2.0; A[0][2]= 1.0; A[0][3]= 0.0; A[0][4]=0.0;}
	if (l == Nxg -1)
    {A[0][0]=0.0; A[0][1]= 0.0; A[0][2]= 1.0; A[0][3]=-2.0; A[0][4]=1.0;}

	if (m == 0)     
    {A[1][0]=1.0; A[1][1]=-2.0; A[1][2]= 1.0; A[1][3]= 0.0; A[1][4]=0.0;}
	if (m == Nyg -1)
    {A[1][0]=0.0; A[1][1]= 0.0; A[1][2]= 1.0; A[1][3]=-2.0; A[1][4]=1.0;}

	// the top/bottom boundary smoothing appears to be of the
	// wrong sign -- fix
	if (n == 0)     
	  //    {A[2][0]=1.0; A[2][1]=-2.0; A[2][2]= 1.0; A[2][3]= 0.0; A[2][4]=0.0;}
    {A[2][0]=-1.0; A[2][1]=2.0; A[2][2]= -1.0; A[2][3]= 0.0; A[2][4]=0.0;}
	if (n == Nzg -1)
	  //    {A[2][0]=0.0; A[2][1]= 0.0; A[2][2]= 1.0; A[2][3]=-2.0; A[2][4]=1.0;}
    {A[2][0]=0.0; A[2][1]= 0.0; A[2][2]= -1.0; A[2][3]=2.0; A[2][4]=-1.0;}

	//Check if we have to force vz= 0 at the top and bottom boundaries
	//when calculating derivatives
	if (HCB == 1 && c == 2 && (n == 0 || n == Nzg -1)) A[2][2] = 0.0;
  
	// 
	// Get Second Partial Derivatives
	//
	del2x = del2y = del2z = 0.0;
	for (pp = 0; pp < 5; pp++) { 

		// Take the opportunity to Scale The Coefficients.
		//A[0][pp] /= dx2;
		//A[1][pp] /= dy2;
		//A[2][pp] /= dz2;

		//
		// Second Partial Derivatives
		//
		if   (fabs(A[0][pp]) > 0.1) 
			del2x +=(A[0][pp]*f[gpe(Nxg,Nyg,Nzg,c,l+2-pp,m,n)]);

		if   (fabs(A[1][pp]) > 0.1) 
			del2y +=(A[1][pp]*f[gpe(Nxg,Nyg,Nzg,c,l,m+2-pp,n)]);

		if   (fabs(A[2][pp]) > 0.1) 
			del2z +=(A[2][pp]*f[gpe(Nxg,Nyg,Nzg,c,l,m,n+2-pp)]);
	}

	d2x[c] = del2x;
	d2y[c] = del2y;
	d2z[c] = del2z;

	// Return Laplacian
	//return( (del2x + del2y + del2z) ); 
}
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
double Flap(struct funInfo *finfo,int N, double *f,double *g){
// 
// Penalty function assocciated with the Laplacian.
// Flap also calculates the gradient of this penalty term.
// respect to the velocity components.
//
//struct CurrentPhysGrid cpg;
	double d2x[3],d2y[3],d2z[3]; //, s3[4];
	double A[3][5];
	//double AX,AY,AZ;
	double Weight,vWeight,NhW,NvW;//,Norma;
	double sum; //, l0,l1,l2;
	int i,j,k;
	int Nxg,Nyg,Nzg;
	float Dxg,Dyg,Dzg;
	int comp;
	int HCB = 1; //HardCodeBoundary =1 for yes, =0 for no
	double Eps = 0.1;

	//int ig,jg;
	ngFitInfo *ginfo = finfo->userData;

	Nxg = ginfo->nx; //(*finfo).grid.Nx;
	Nyg = ginfo->ny; //(*finfo).grid.Ny;
	Nzg = ginfo->nz; //(*finfo).grid.Nz;
	Dxg = ginfo->dx; //(*finfo).grid.Dx;
	Dyg = ginfo->dy; //(*finfo).grid.Dy;
	Dzg = ginfo->dz; //(*finfo).grid.Dz;
	Weight = ginfo->PHS; //(*finfo).PHS;
	vWeight = ginfo->PVS; //(*finfo).PVS;
	//TODO Nobs???
	//Norma = (*finfo).rd.Nobs;

	//NhW = Weight/Norma; // Normalized Horizontal Weight.
	//NvW = vWeight/Norma; 
	NhW = Weight;
	NvW = vWeight;

	//
	//
	//hsum = vsum = 0.0;
	sum = 0.0;
	for (i = 0; i < Nxg; i++) {
		for (j = 0; j < Nyg; j++) {
			for (k = 0; k < Nzg; k++) {
      
				lap(HCB,Nxg,Nyg,Nzg,0,i,j,k,A,d2x,d2y,d2z,f);
				//lap(HCB,Nxg,Nyg,Nzg,1,i,j,k,A,d2x,d2y,d2z,f);

				sum += ( (d2x[0]*d2x[0] + d2y[0]*d2y[0]) *  NhW);
				//sum += ( (d2x[1]*d2x[1] + d2y[1]*d2y[1]) *  NhW);
				//sum += ( (d2z[0]*d2z[0] + d2z[1]*d2z[1]) *  NvW);
				sum += ((d2z[0] * d2z[0]) * NvW);

				//
				// Get gradient componets
				//
				//for (comp = 0; comp < 2; comp++) {	// only U and V.
				for (comp = 0; comp < 1; comp++) {	// only U and V.

					if ( fabs(A[0][0]) > Eps && (i < Nxg -2) ) 
						g[gpe(Nxg,Nyg,Nzg,comp,i+2,j,k)] += NhW * A[0][0] * d2x[comp];

					if ( fabs(A[0][1]) > Eps && (i < Nxg -1)) 
						g[gpe(Nxg,Nyg,Nzg,comp,i+1,j,k)] += NhW * A[0][1] * d2x[comp];

					if ( fabs(A[0][2]) > Eps) 
						g[gpe(Nxg,Nyg,Nzg,comp,i,j,k)]   += NhW * A[0][2] * d2x[comp];

					if ( fabs(A[0][3]) > Eps && i > 0) 
						g[gpe(Nxg,Nyg,Nzg,comp,i-1,j,k)] += NhW * A[0][3] * d2x[comp];

					if ( fabs(A[0][4]) > Eps && i > 1) 
						g[gpe(Nxg,Nyg,Nzg,comp,i-2,j,k)] += NhW * A[0][4] * d2x[comp];
        
					//--

					if ( fabs(A[1][0]) > Eps && (j < Nyg -2) ) 
						g[gpe(Nxg,Nyg,Nzg,comp,i,j+2,k)] += NhW * A[1][0] * d2y[comp];

					if ( fabs(A[1][1]) > Eps && (j < Nyg -1) ) 
						g[gpe(Nxg,Nyg,Nzg,comp,i,j+1,k)] += NhW * A[1][1] * d2y[comp];

					if ( fabs(A[1][2]) > Eps) 
						g[gpe(Nxg,Nyg,Nzg,comp,i,j,k)]   += NhW * A[1][2] * d2y[comp];

					if ( fabs(A[1][3]) > Eps && j > 0) 
						g[gpe(Nxg,Nyg,Nzg,comp,i,j-1,k)] += NhW * A[1][3] * d2y[comp];

					if ( fabs(A[1][4]) > Eps && j > 1) 
						g[gpe(Nxg,Nyg,Nzg,comp,i,j-2,k)] += NhW * A[1][4] * d2y[comp];

					//--


					if ( fabs(A[2][0]) > Eps && (k < Nzg -2) ) 
						g[gpe(Nxg,Nyg,Nzg,comp,i,j,k+2)] += NvW * A[2][0] * d2z[comp];

					if ( fabs(A[2][1]) > Eps && (k < Nzg -1) ) 
						g[gpe(Nxg,Nyg,Nzg,comp,i,j,k+1)] += NvW * A[2][1] * d2z[comp];

					if ( fabs(A[2][2]) > Eps) 
						g[gpe(Nxg,Nyg,Nzg,comp,i,j,k)]   += NvW * A[2][2] * d2z[comp];

					if ( fabs(A[2][3]) > Eps && k > 0) 
						g[gpe(Nxg,Nyg,Nzg,comp,i,j,k-1)] += NvW * A[2][3] * d2z[comp];

					if ( fabs(A[2][4]) > Eps && k > 1) 
						g[gpe(Nxg,Nyg,Nzg,comp,i,j,k-2)] += NvW * A[2][4] * d2z[comp];

				}

				if (sum > DBL_MAX/2.0){
					// if this condition comes up, we just have to 
					// apply the normlizat term by term.
					fprintf(stderr,"DBLMAX exceeded!!\n");
					exit(1);
				}
			}//kloop
		}//jloop
	}//iloop

	return(0.5*(sum)); // apply scaling to function
}
//-------------------------------------------------------------------
