#ifndef NGGFIT_H_INCLUDED
#define NGGFIT_H_INCLUDED

#include "ngcmdargs.h"

typedef struct _ngFitInfo
{
	unsigned int nx, ny, nz; //number of grid elements
	float dx, dy, dz;  //step size of the grid in the x, y, and z directions.
	double PHS, PVS; //horizontal and vertical weight
	double *data; //original data
	double *auxG; //auxilary gradient
	double *bgf;  // background field.
	double bgfW;  //weight for the bgf term.
	float bad, badlim; //data file bad data limits
} ngFitInfo;

/**
 * Prefom a global fit on a given set of data.
 *
 * @param args The commandline arguments.
 * @param findex The index on which to preform the global fit on.
 * @param data The data from the local fit on the given index.
 */
void ngGlobalFit(ngCMDArgs *args, unsigned int findex, float *data, float bad, float badlim);

#endif
