/* addcommand -- This routine adds the command line to a header buffer.
 * The command line is broken into rows of less than LINE characters.
 * Lines are only broken at whitespace, unless there is none.
 * These are added to the header comment, with each line after the first
 * being indented 2 spaces.
 */

#include <stdio.h>
#include "cdfhdr.h"
#include <string.h>

int addcommand(argc,argv,buffer)
int argc;
char *argv[];
char buffer[][LINE];
{
  int i,j,arglen;
  int row = 0;
  int nchars = 0;
  int firstword = 0;
  char commline[HBMAX][LINE];
/*loop thru arguments using argc */
  for(i = 0;i < argc; i++){
    arglen = strlen(argv[i]);
/* only add the next word if it will fit on the line */
    if(nchars + arglen + 1 < LINE-1){
/* insert space after each word */
      if(firstword == 0){
        firstword = 1;
      }else{
        commline[row][nchars++] = ' ';
      }
/* loop thru nchars in the current argument */
      for(j = 0;j < arglen; j++){
        commline[row][nchars++] = argv[i][j];
      }
    }else{
/* when row is filled, add to header buffer */
      commline[row][nchars] = '\n';
      addcline(buffer,HBMAX,commline[row]);
/* indent lines after the first */
      strncpy(commline[++row],"  ",2);
      nchars = 2;
      firstword = 0;
      i--;
    }
  }
/* add the last line to the buffer */
  commline[row][nchars++] = '\n';
  addcline(buffer,HBMAX,commline[row]);
}
