/* addpar.c -- This routine adds a parameter name-value pair to a
 * header buffer.  Various error exits occur if there are problems.
 */
#include <stdio.h>
#include "cdfhdr.h"
#include "string.h"

addpar(buffer,max,pname,pval)
char buffer[][LINE],*pname,*pval;
int max;
{
  int loop,length;
  char line[LINE],temp[LINE];
/* check for excessive length */
  if ((strlen(pname) + strlen(pval) + 4) > LINE) {
    fprintf(stderr,"addparam: pname = %s + pval = %s too long\n",pname,pval);
    exit(1);
  }
/* make up line */
  sprintf(line,"%s %s\n",pname,pval);
/* find end of buffer */
  length = 0;
  for (loop = 6; loop < max - 1; loop++) {
    if (ETEST(loop)) {
      length = loop;
      break;
    }
  }
/* test for bad format */
  if (length == 0) {
    fprintf(stderr,
      "addparam: Bad header buffer format or no more buffer space\n");
    exit(1);
  }
/* ripple down to make room for new insert */
  for (loop = length; loop > 0; loop--) {
    strcpy(buffer[loop + 1],buffer[loop]);
    sscanf(buffer[loop],"%s",temp);
    if (strcmp(temp,SSH) == 0) {
      strcpy(buffer[loop],line);
      return;
    }
  }
/* error if we couldn't find paramater list sub-header */
  fprintf(stderr,"addparam: Bad header buffer format\n");
  exit(1);
}
