/* getptr -- This routine returns a pointer to a field, given the
 * name of the field, its type, and the locations of the header and
 * slice buffers.  Failure mode is either to die with an error
 * message or to return NULL, depending on the value of failmode.
 */
#include <stdio.h>
#include "cdfhdr.h"

float *getptr(hbuff,max,sbuff,type,failmode,fname)
char hbuff[][LINE];      /* header buffer */
int max;                 /* max lines in header buffer */
float *sbuff;            /* pointer to slice buffer */
char type;               /* 's' = static slice, 'v' = variable slice */
char failmode;           /* 'r' = return NULL, 'd' = die with error message */
char *fname;             /* field name */
{
  struct field *fp;
  if ((fp = seekfld(hbuff,max,type,fname)) == NULL) {
    if (failmode == 'd') {
      fprintf(stderr,"getptr: can't find %s in %c slice\n",fname,type);
      exit(1);
    }
    else {
      return(NULL);
    }
  }
  return(sbuff + fp->ptr);
}
