/* nullhdr -- This routine creates a null header in buffer of type
 * format -- "float", "int", or "ascii".  If max < 10, it dies with a message
 * that the buffer isn't big enough.  It also dies if format isn't a
 * recognized type.
 */

#include <stdio.h>
#include "cdfhdr.h"

nullhdr(buffer,max,format)
char buffer[][LINE],*format;
int max;
{
  if (max < 10) {
    fprintf(stderr,"nullhdr: max = %d -- header buffer not big enough\n",max);
    exit(1);
  }
  if ((strcmp(format,"float") != 0) && (strcmp(format,"int") != 0) &&
    (strcmp(format,"ascii") != 0)) {
    fprintf(stderr,"nullhdr: format = %s is unrecognized type\n",format);
    exit(1);
  }
  sprintf(buffer[0],"%s\n",CSH);
  sprintf(buffer[1],"%s\n",PSH);
  sprintf(buffer[2],"%s\n",SSH);
  sprintf(buffer[3],"%s\n",VSH);
  sprintf(buffer[4],"%s\n",FSH);
  sprintf(buffer[5],"%s\n",format);
  sprintf(buffer[6],"%c\n",ENDCHAR);
}
