/* seekpar.c -- This routine scans through a common data format header
 * buffer looking for a specified parameter name.  If found, it returns an OK
 * after putting the value of the parameter in value.  At most, max lines
 * of the buffer will be scanned.  If the end of the buffer is actually
 * reached, a format error in the header exists.  This causes a fatal
 * error.  If the desired parameter isn't found, a FAIL is returned.
 */
#include <stdio.h>
#include "cdfhdr.h"
#include "string.h"
static int fatal();
static char b1[LINE],b2[LINE];
int seekpar(buffer,max,pname,value)
int max;
char buffer[][LINE],pname[],value[];
{
  int count;
  count = 0;
/* find parameter area of buffer */
  for (;;) {
    if (count >= max) fatal();
    if (ETEST(count)) fatal();
    sscanf(buffer[count],"%s",b1);
    count++;
    if (strcmp(b1,PSH) == 0) break;
  }
/* search through parameter list */
  for (;;) {
    if (count >= max) fatal();
    if (ETEST(count)) fatal();
    sscanf(buffer[count],"%s %s",b1,b2);
    if (strcmp(b1,SSH) == 0) return(FAIL);
    if (strcmp(b1,pname) == 0) {
      strcpy(value,b2);
      return(OK);
    }
    count++;
  }
}
/* fatal error -- format problem in header buffer */
static int fatal()
{
  fprintf(stderr,"seekpar: format error in header buffer\n");
  exit(1);
}
