/*  gotosis.go
	This program will take a candis file and output the data in the file 
	in Fibre Format.

	Usage:
	gotosis < candis_file
 */


package main
import (
	"fmt"
	"gocandis"
)


//Functions to print different arrays in Firbre Format
//================================================================

func fibreInt(a []int) {
	fmt.Printf("[0:")
	for i := range a{
		fmt.Printf(" %d", a[i])
	}
	fmt.Printf("]")	
}

func fibreString(a []string) {
	fmt.Printf("[0:")
	for i := range a {
		fmt.Printf(" \"%s\"", a[i])
	}
	fmt.Printf("]")
}

func fibreArrayString(a [][]string) {
	fmt.Printf("[0:")
	for i := range a {
		fibreString(a[i])
	}
	fmt.Printf("]")
}

func fibreFloat(a []float64){
	fmt.Printf("[0:")
	for i := range a {
		fmt.Printf(" %f", a[i])
	}
	fmt.Printf("]")

}	

func fibreArrayFloat(a [][]float64) {
	fmt.Printf("[0: ")
	for i := range a {
		fibreFloat(a[i])
	}
	fmt.Printf("]")
}

func fibreField(names []string, dims [][]string, sizes []int, data [][]float64){
	fmt.Printf("[0:")
	for i := range names {
		fmt.Printf(" <\"%s\" [0:", names[i])
		
		for j := range dims[i] {
			fmt.Printf(" \"%s\"", dims[i][j])
		}
		fmt.Printf("] %d ", sizes[i])
		fibreFloat(data[i])
		fmt.Printf(">")
	}
}

//======================================================================

func main() {
	c := gocandis.GetCandis("-")

	fmt.Printf("<")

	comments := c.GetComments()
	fibreString(comments)

	fmt.Printf(" ")

	// Get Parameters and print them
	paramNames := c.GetParamNames()
	paramVals := make([]string,0,50)
	for i := range paramNames {
		paramVals = append(paramVals, c.GetParamValue(paramNames[i]))
	}

	fmt.Printf("[0:")
	for i := range paramNames {
		fmt.Printf(" <\"%s\" \"%s\">", paramNames[i], paramVals[i])
	}

	fmt.Printf("] ")

	// Get dimension names and print them
	DimNames := c.GetDimNames()
	fibreString(DimNames)

	fmt.Printf(" ")

	// Get the size and data of each of the dimensions and print the sizes
	DimSizes := make([]int,0,50)
	DimData := make([][]float64,0,50)
	for i := range DimNames {
	 	DimData = append(DimData, c.GetFieldData(DimNames[i]))
		DimSizes = append(DimSizes, len(DimData[i]))
	}
	fibreInt(DimSizes)
	
	fmt.Printf(" ")

	// Get the dimension of each dimension and print the static fields
	DimDims := make([][]string,0,50)
	for i := range DimNames {
	 	DimDims = append(DimDims, c.GetFieldDims(DimNames[i]))
	}

	fibreField(DimNames, DimDims, DimSizes, DimData)

	fmt.Printf("] ")

	// Get the names, dimensions, and sizes for the variable fields
	VFieldNames := c.GetVFieldNames()
	VFieldDims := make([][]string,0,50)
	VFieldSizes := make([]int,0,50)
	for i := range VFieldNames {
	 	VFieldDims = append(VFieldDims, c.GetFieldDims(VFieldNames[i]))
		
		size := 1
		for _, vname := range VFieldDims[i] {
			for i, dname := range DimNames {
				if vname == dname {
					size = size * DimSizes[i]
					break
				}
			}
		}

		VFieldSizes = append(VFieldSizes, size)
	}

	// Get the data for the variable fields, and then print the variable fields
	VFieldData := make([][]float64,0,50)
	for i := range VFieldNames {
	 	VFieldData = append(VFieldData, c.GetFieldData(VFieldNames[i]))
	}

	fibreField(VFieldNames, VFieldDims, VFieldSizes, VFieldData)

	fmt.Printf("]>")
	c.CloseCandis()

}
