#!/bin/sh
#
# mr.sh -- Calculate mixing ratio from T, p, RH
#
if test $# != 3
then
    echo "Usage: mr.sh temp(C) pres(hPa) relhum(%)"
else
    temp=$1
    pres=$2
    relhum=$3
    tmpfile=dummy$$

    cdfnull dummy 1 0 1 | \
	cdfmath "$temp temp =" | \
	cdfmath "$pres pres =" | \
	cdfmath "$relhum 0.01 * relhum =" | \
	cdfmr pres temp temp mr | \
	cdfmath "mr relhum * mr =" > $tmpfile

    mr=`cdfsprt.sh mr < $tmpfile`
    rm $tmpfile

    echo "T = $temp C,  p = $pres hPa, RH = ${relhum}%, mr = $mr g/kg"
fi
